#include <iostream>
#include <iomanip>
#include "myrn.h"		//	乱数生成用クラス型 WHrn のヘッダーファイル

using namespace std;
using namespace myrn;
//
//	0 < v < 1 の範囲の値を　0 ~ 5 の範囲の整数値に変換
//
int Cat( double v ){
	return  int(v * 6.0);
}
//
//	Fiに格納された頻度とその比率の表示
//	平均値は、0 ~ 5 を 1 ~ 6 の値にシフトさせ、サイコロの目の数とみなして計算
//
void disp_data( int * Fi, int i ){
	cout << endl << "i = " << i << endl;
	cout << left << setw(5) << "Fi =";
	for (int k = 0; k < 6; k++)
		cout << right << setw(10) << Fi[k];
	cout << endl << left << setw(5) << "Pi =";
	for (int k = 0; k < 6; k++)
		cout << right << setw(10) << fixed << setprecision(5) << (Fi[k] / double(i));
	cout << endl;
	double sum = 0.0;
	for (int k = 0; k < 6; k++)
		sum += (k+1.0)*Fi[k];
	cout << "mean = " << fixed << setprecision(5) << (sum / i) << endl;
}

int main()
{
	WHrn rn;
	int Fi[] = {0, 0, 0, 0, 0, 0};
	double Pi[6];
	const int MaxN = 1000000;
	for (int i = 1; i <= MaxN; i++){
		Fi[Cat(rn.uni())]++;	//	0 ~ 5 の整数をランダムに生成し、対応するFiの要素の値を １ 増やす
		//
		//		途中経過の表示
		switch(i){
			case 10:	disp_data( Fi, i );	break;
			case 20:	disp_data( Fi, i );	break;
			case 100:	disp_data( Fi, i );	break;
			case 1000:	disp_data( Fi, i );	break;
			case 10000:	disp_data( Fi, i );	break;
			default:	break;
		}
	}
	disp_data( Fi, MaxN );	
    	return 0;
}
